# AUTOGENERATED! DO NOT EDIT! File to edit: 00_04_music.ipynb (unless otherwise specified).

__all__ = ['music']

# Cell

from ...formats import list_to_r_vector
import os

# Cell

def music(bulk_rds,sc_rds,cluster,samples,output,select_ct='NULL',bulk_filter=20,sc_filter=20,rscript='/usr/bin/env Rscript'):
    '''
    '''
    if select_ct != 'NULL':
        select_ct = list_to_r_vector(select_ct)


    return r'''#! {rscript}


library(MuSiC)
library(xbioc)

bulk_rds <- '{bulk_rds}'
sc_rds <- '{sc_rds}'
clusters <- '{cluster}'
samples <- '{samples}'
output <- '{output}'

select.ct <- {select_ct}

bulk_eset <- readRDS(bulk_rds)
sc_eset <- readRDS(sc_rds)
filtered_bulk <- bulk_eset[unlist(rowSums(exprs(bulk_eset)))>{bulk_filter},]
filtered_sc <- sc_eset[unlist(rowSums(exprs(sc_eset)))>{sc_filter},]

Est.prop <- music_prop(bulk.eset = filtered_bulk,
                      sc.eset = filtered_sc,
                      clusters = clusters,
                      samples = samples,
                      select.ct = select.ct,
                      verbose = F)

saveRDS(Est.prop, file = paste('{output}', 'rds', sep = '.'))
write.csv(Est.prop$Est.prop.weighted, '{output}', quote = FALSE)

'''.format(**locals())